function mylpgui(action)

global seg
global Nlarge
global Nmedium
global Nsmall
global T1
global T2
global T3
global Lpoly
global pf
global ppulse
global pseg
global psp1
global psp2
global psp3

lseg=length(seg);
switch(action)
    
case 'loadpulse',
    loadpulse;
case 'NSs'
    NS=findobj(gcbf,'Tag','slider9');
    Nsmall=round(get(NS,'Value'));
    NStext=findobj(gcbf,'Tag','edit1');
    set(NStext,'String',num2str(Nsmall));
case 'NMs'
    NM=findobj(gcbf,'Tag','slider10');
    Nmedium=round(get(NM,'Value'));
    NMtext=findobj(gcbf,'Tag','edit2');
    set(NMtext,'String',num2str(Nmedium));    
case 'NLs'
    NL=findobj(gcbf,'Tag','slider12');
    Nlarge=round(get(NL,'Value'));
    NLtext=findobj(gcbf,'Tag','edit3');
    set(NLtext,'String',num2str(Nlarge));    
case 'start1',
    set(gcbf,'WindowButtonMotionFcn','mylpgui move1');
    set(gcbf,'WindowButtonUpFcn','mylpgui stop1');
case 'move1',
    currPt=get(gca,'CurrentPoint');
    T1=round(max(50,min(T2-50,currPt(1,1))));
    set(psp1,'XData',[T1 T1]);
case 'stop1',
    set(gcbf,'WindowButtonMotionFcn','');
    set(gcbf,'WindowButtonUpFcn','');
case 'start2',
    set(gcbf,'WindowButtonMotionFcn','mylpgui move2');
    set(gcbf,'WindowButtonUpFcn','mylpgui stop2');
case 'move2',
    currPt=get(gca,'CurrentPoint');
    T2=round(max(T1+50,min(T3-50,currPt(1,1))));
    set(psp2,'XData',[T2 T2]);
case 'stop2',
    set(gcbf,'WindowButtonMotionFcn','');
    set(gcbf,'WindowButtonUpFcn','');
case 'start3',
    set(gcbf,'WindowButtonMotionFcn','mylpgui move3');
    set(gcbf,'WindowButtonUpFcn','mylpgui stop3');
case 'move3',
    lseg=length(seg);
    currPt=get(gca,'CurrentPoint');
    T3=round(max(T2+50,min(lseg-50,currPt(1,1))));
    set(psp3,'XData',[T3 T3]);
case 'stop3',
    set(gcbf,'WindowButtonMotionFcn','');
    set(gcbf,'WindowButtonUpFcn','');
case 'pf_flag',
    %pff_o=findobj(gcbf,'Tag','radiobutton1');
    %pf=round(get(pff_o,'Value'));
    pf=~pf;
    pf_o=findobj(gcbf,'Tag','slider7');
    if pf,
        set(pf_o,'Enable','On');
    elseif ~pf
        %pf_o=findobj(gcbf,'Tag','slider7');
        set(pf_o,'Enable','Off');
    end
case 'polyf'
    pf_o=findobj(gcbf,'Tag','slider7');
    Lpoly=round(get(pf_o,'Value'));    
    Lpolytext=findobj(gcbf,'Tag','edit4');
    set(Lpolytext,'String',num2str(Lpoly)); 
end
lseg=length(seg);
maxs=max(seg);
mins=min(seg);
pe=pulse_estimate(seg,Nlarge,Nmedium,Nsmall,T1,T2,T3,Lpoly,pf); 

set(ppulse,'YData',pe);
%plot(1:lseg,seg,[T1 T1],[-1 1],[T2 T2],[-1 1],[T3 T3],[-1 1])
%hold on
%plot(1:lseg,pe,'-k','linewidth',2);
%axis([1 lseg mins*1.1 maxs*1.1])
%hold off



function loadpulse
%function [seg,Nlarge,Nmedium,Nsmall,T1,T2,T3,Lpoly,pf]=loadpulse(a);


global seg
global Nlarge
global Nmedium
global Nsmall
global T1
global T2
global T3
global Lpoly
global pf
global ppulse
global pseg
global psp1
global psp2
global psp3


load ex_pulse   % loads s and cl (click location)

seg=s;
seg=seg(1:5000);
lseg=length(seg);

%sp2=findobj(gcbf,'Tag','slider2');
%sp3=findobj(gcbf,'Tag','slider3');

%set(sp2,'Min',cl+50,'Value',cl+500);
%set(sp3,'Min',cl+500+50,'Value',cl+500+50+1000);
%sp2_value=round(get(sp2,'Value'));
%sp3_value=round(get(sp3,'Value'));
%set(sp2,'Max',sp3_value-50);
%set(sp3,'Max',lseg);

maxs=max(seg);
mins=min(seg);



NL=findobj(gcbf,'Tag','slider12');
NM=findobj(gcbf,'Tag','slider10');
NS=findobj(gcbf,'Tag','slider9');
LP=findobj(gcbf,'Tag','slider7');

Nlarge=round(get(NL,'Value'));
Nmedium=round(get(NM,'Value'));
Nsmall=round(get(NS,'Value'));
Lpoly=round(get(LP,'Value'));


T1=cl;
T2=cl+500;
T3=cl+1550;

pf_flag=findobj(gcbf,'Tag','radiobutton1');
pf=get(pf_flag,'Value');


if 0
pe=pulse_estimate(seg,Nlarge,Nmedium,Nsmall,T1,T2,T3,Lpoly,pf); 
plot(1:lseg,seg,[cl cl],[-1 1],[sp2_value sp2_value],[-1 1],[sp3_value sp3_value],[-1 1])
hold on
plot(1:lseg,pe,'-k','linewidth',2);
axis([1 lseg mins*1.1 maxs*1.1])
hold off
end

if 1
pe=pulse_estimate(seg,Nlarge,Nmedium,Nsmall,T1,T2,T3,Lpoly,pf); 
pseg=plot(1:lseg,seg);
axis([1 lseg mins*1.1 maxs*1.1])
hold on
psp1=plot([cl cl],[-1 1],'Color',[1 .7 0],'linewidth',1.3);
psp2=plot([T2 T2],[-1 1],'-r','linewidth',1.3);
psp3=plot([T3 T3],[-1 1],'-g','linewidth',1.3);
ppulse=plot(1:lseg,pe,'-k','linewidth',2);

set(psp1,'ButtonDownFcn','mylpgui start1','EraseMode','xor');
set(psp2,'ButtonDownFcn','mylpgui start2','EraseMode','xor');
set(psp3,'ButtonDownFcn','mylpgui start3','EraseMode','xor');

%hold off
end



set(NL,'Enable','On');
set(NM,'Enable','On');
set(NS,'Enable','On');
set(pf_flag,'Enable','On')
%set(sp2,'Enable','On');
%set(sp3,'Enable','On');

loadbutton=findobj(gcbf,'Tag','pushbutton1');
set(loadbutton,'Enable','Off')

function [pa]=piecefit_mod(x,winl,po);

% This function implements the second stage of the pulse estimation method: 
%  piecewise polynomial fiiting.
%
% Input arguments
%
% 'x': the imput signal, i.e., the pulse estimate output from the first stage (TPSW)
% 'winl': is the window length in samples
% 'po': is the polynomial order
% 
% Output:
% 
% pa: smoothed pulse estimate

% Paulo Esquef 28.09.2002
% Latest updates: 02.10.2002
x=x(:);
seg=round(winl);
mo=po;

% The overlap factor is fixed at 75%. Hence we need to check if winl is divisible by 4.
% If not we reduce winl until it be so.  

while (mod(seg,4)~=0),
  seg=seg-1;
end

sp=seg*.75;  % The overlap factor is fixed at 75% 

w=hanning(seg); w=w(:)./2; % Hanning is used in this case. The 1/2 factor is due to the
                           % 75% overlap.
ls=length(x);
basis=1:seg; basis=basis(:); % this vector contains the values for which the polynomial is evaluated;

nblocks=fix((ls-sp)/(seg-sp));  % calculate the number of blocks used in the procedure;
                                % better treatment of the borders would be nice to be included
	
output=zeros(ls,1);    % creates beforehand the output signal; this alleviates the burden of border treatment

for kk=0:(nblocks-1),
   bump=x(kk*(seg-sp)+(1:seg)); bump=bump(:);% segment to be fitted
   p=polyfit(basis,bump,mo);    % computes the values of the polynomial coefficients
   smbump=polyval(p,basis);     % evaluates the polynomial within the predefined interval 
   smbump=smbump(:);
   output(kk*(seg-sp)+(1:seg))=output(kk*(seg-sp)+(1:seg))+(smbump.*w);
end

lo=length(output);
pa=output;
   
%plot(1:lo,x(1:lo),1:lo,output); pause

function pe=pulse_estimate(seg,Nlarge,Nmedium,Nsmall,T1,T2,T3,Lpoly,pf); 

% This script implements the de-thump (low-frequency pulse removal) method proposed in the AES112 paper (preprint 5535)
%
% Uses functions:
%       - mrtpswma.m 
%           - tpswma.m  
%       - piecefit_mod.m (polynomial fit with 75% overlap factor)    
%
% Uses files:
%       - Medley-waltz.wav and p_loc_medley.mat
%
% Paulo Esquef 28.09.2002
% Latest updates: 28.09.2002

%s=s(:,1);                              % Only one channel is treated.



Tv=[T2-T1; T3-T2];                       % T_small and T_medium in samples. 
Nv=[Nsmall Nmedium Nlarge];                       % N_small, N_medium, and N_large in samples.
fit_frame=Lpoly;                          % Length of the frames in the piecefit polynomial scheme.
poly_order=2;                          % Polynomial order in the piecefit scheme.
 
cl=[T1];
[pe]=splice_tpsw(seg,[cl],Nv,Tv);            % Performs TPSW filtering with splicing strategy (first stage).
if pf,
    [pe]=piecefit_mod(pe,fit_frame,poly_order);  % Pulse estimate after piecewisw polynomial fitting with a 
end                                             % second order polynomial (second stage).

function [tpswe]=splice_tpsw(x,clicks,wl,wt);
% This function performs the first stage of the de-thumping scheme: variable-length
% TPSW filtering using spliced estimates. 
%
% Inout arguments:
% 
% x: input signal to be de-thumped;
% clicks: vector containing the indices of the initial clicks that indicate the 
%         beginning of a pulse;
% wl:  a 3-element vector with the length of the 3 split-windows to be used;
% wt; a 2 element vecotr that indicates the splicing points; 
%
% Output: 
%
% tpswe: tpsw-based pulse estimate;
%
% Splicing strategy:
%
% It uses the the information
% provided in the vector clicks, wl and, wt. The procedure goes as follows:
%
%   1) the tpsw estimate of length wl(3) is used as a basis;
%   2) starting from clicks(1) we replace wt(1) samples of the basis with wt(1) 
%      samples taken from the tpsw estimate of length wl(1). 
%      After that, (from clicks(1)+wt(1)), we replace wt(2) samples 
%      of the basis with the tpsw estimate of length wl(2). 
%   3) This is repeated for all indices given in the vector clicks. 
% 
% There is also a crossfading scheme embeded in the procedure!
%
% Paulo Esquef 28.09.2002
% Latest updates: 02.10.2002


% First, we check if there are clicks in the signal segment

if ~isempty(clicks), 

   % We build some windows based on the wl values

   fade_l=20;   % length of the fade in and fade out parts of the window
   fd_in= ((0:(fade_l-1))/fade_l)';
   fd_out=flipud(fd_in);
   w_small=[fd_in;ones(wt(1),1);fd_out];
   w_medium=[fd_in;ones(wt(2),1);fd_out];
   w_small_mirror=1-w_small;
   w_medium_mirror=1-w_medium;

   % Then, we compute the TPSW estimates with different windows (those given in wl)

   for kk=1:length(wl),
      X(:,kk)=tpswma(x,length(x),round(wl(kk)/2),5,2);
   end
   
   % The estimate basis is X(:,3)!!
   
   le=length(X(:,3));
   
   lc=length(clicks);
   for k=1:lc,
      % small window
      sp1=clicks(k);                                          % splicing point 1
      range=sp1-fade_l-1+(1:(2*fade_l+wt(1)));               % sets the replacement range
      if max(range)<=le,
         X(range,3)=w_small_mirror.*X(range,3)+w_small.*X(range,1); % replaces the signal using cross fading 
      %else
      %   disp('The splicing point sp1 is to close to the end of the frame! Replacement was not done!')
      end
      % medium window
      sp2=sp1+wt(1); 
      range=sp2-fade_l-1+(1:(2*fade_l+wt(2)));
      if  max(range)<=le,
         X(range,3)=w_medium_mirror.*X(range,3)+w_medium.*X(range,2); % replaces the signal using cross fading 
      %else
         %disp('The splicing point sp2 is to close to the end of the frame! Replacement was not done!')
      end
      %sp1
      %sp2
      %pause
   end

   % Fades out smoothly the TPSW estimate obtained at this stage with a half-end Hanning window 
   
   tpswe=X(:,3); %clear X(:,3)
   lo=length(tpswe);   
   nn=2049;
   hhw=hanning(nn);
   hhw(1:((nn+1)/2-1))=[];
   lh=length(hhw);
   tpswe((lo-lh+1):lo)=tpswe((lo-lh+1):lo).*hhw;

else,
   tpswe=zeros(length(x),0);
end

function mx=tpswma(x,npts,n,p,a)
% |
% |[mx] = tpsw(x,npts,n,p,a)
% |
% | Claculates a local median estimate for the vector x using the 
% |"two-pass split window" algorithm
% |
% | where:	x	= input vector
% |		npts	= number of points in x to be processed
% |		n	= half of the length of the window 
% |		p	= half of the length of the central gap
% |		a	= constant for the threshold computation
% |
% |		mx	= output vector
% |________________________________________________________
% |

% Based on the original program by 

% |William Soares-Filho
% |Instituto de Pesquisas da Marinha, RJ- Brazil


% Input arguments checking
%
%if nargin<1,help tpsw;return;end	% show help (without arguments)
if min(size(x))==1,x=x(:);end		% change input vector to column form
if nargin<2,npts=size(x,1);end		% length of the input vector
x=x(1:npts,:);
if nargin<3,n=round(npts*.04/2+1);end	% length of the window
if nargin<4,p=round(n/8+1);end		% length of the central gap
if nargin<5,a=2.0;end			% constant for the threshold calculus

% First pass using the gapped window
%
h=[ones(1,n-p+1) zeros(1,2*p-1) ones(1,n-p+1)];	% sets the filter
h=h(:);
h=h/norm(h,1);					% normalization


x=x(:);
mx=filter2(h,x,'same');


% Peak removal before second pass

ind1=find(abs(x-mx)>abs(mx-a*mx));
x(ind1)=mx(ind1);				


% second pass using window without the central gap

h2=ones(length(h),1);
h2=h2/norm(h2,1);	

mx=filter2(h2,x,'same');


